#!/usr/bin/perl

 if (@ARGV[0] eq "") {
   print "usage: makesp MMF SPMMF\n";
   exit(0);
 }

 $silDetect   = "FALSE";
 $outPrint    = "TRUE";
 $startBuffer = "FALSE";
 $spModel  = "";

 unless (open(MMF, "@ARGV[0]")) {
   die ("can't open @ARGV[0]");
 }

  unless (open(SPMMF, ">@ARGV[1]")) {
   die ("can't open @ARGV[1]");
 }

 while ($line = <MMF>) {
 
 if ($line =~ /"sil"/) {
   $silDetect  = "TRUE";
   $spModel   .= "~h \"sp\"\n";
   $spModel   .= "<BEGINHMM>\n";
   $spModel   .= "<NUMSTATES> 3\n";
   $spModel   .= "<STATE> 2\n";
 }

 if ($silDetect eq "TRUE" && ($line =~ /<STATE> 3/)) {
   print SPMMF $line;
   $line = <MMF>;
   $startBuffer = "TRUE";
 } 

 if ($silDetect eq "TRUE" && ($line =~ /<STATE> 4/)) {
   $startBuffer = "FALSE";
 } 

 if ($silDetect eq "TRUE" && $startBuffer eq "TRUE") {
   $spModel .= $line;
 } 
 if ($silDetect eq "TRUE" && ($line =~ /TRANSP/)) {
   $spModel .= "<TRANSP> 3\n";
   $spModel .= " 0.000000e+00 5.000000e-01 5.000000e-01\n";
   $spModel .= " 0.000000e+00 5.000000e-01 5.000000e-01\n";
   $spModel .= " 0.000000e+00 0.000000e+00 0.000000e+00\n";
 } 

 if ($silDetect eq "TRUE" && ($line =~ /ENDHMM/)) {
   $spModel .= $line;
   print SPMMF $line;
   print SPMMF $spModel;
   print $spModel;
   $silDetect = "FALSE";
   $outPrint  = "FALSE";
 } 


 if ($outPrint eq "TRUE") {
   print SPMMF $line;
 }else {
   $outPrint = "TRUE";
 }

}
